include copyfile.inc

.data

msg1 db 'copyfile srcfile.ext destfile.ext',13,10,0

.code

main PROC C uses esi edi ebx argc:DWORD,argv:DWORD

LOCAL pMem:DWORD
LOCAL NumOfBytesRead:DWORD
LOCAL NumOfBytesWritten:DWORD
LOCAL hRead:DWORD
LOCAL hWrite:DWORD

    cmp     argc,1+2
    je      @f
    invoke  StdOut,ADDR msg1
    ret 
@@:
    invoke  VirtualAlloc,0,64*1024,\
            MEM_COMMIT,PAGE_EXECUTE_READWRITE

    mov     pMem,eax

    mov     esi,argv
    lea     edi,NumOfBytesRead
    xor     ebx,ebx

    invoke  CreateFile,DWORD PTR [esi+4],GENERIC_READ,0,0,\
            OPEN_EXISTING,0,0
    mov     hRead,eax    

    invoke  CreateFile,DWORD PTR [esi+8],GENERIC_WRITE,0,0,\
            CREATE_ALWAYS,0,0
    mov     hWrite,eax

@@:
    invoke  ReadFile,hRead,pMem,64*1024,edi,0
    mov     esi,DWORD PTR [edi]
    invoke  WriteFile,hWrite,pMem,esi,ADDR NumOfBytesWritten,0
    add     ebx,esi
    test    esi,esi
    jnz     @b

    invoke  VirtualFree,pMem,0,MEM_RELEASE
    ret

main ENDP

END


